-- Friend system!
local function PRINTF(p,m) CONS_Printf(p,m) end -- discard the third argument
COM_AddCommand("combi_friend", function(player, friend, in_chat)
	local printfunc = in_chat and chatprintf or PRINTF
	local color = in_chat and "\x84" or ""
	
	if not hcombi.cv_combi.value then
		if not in_chat then
			printfunc(player, color .. "Combi isn't on right now.", false)
		end
		
		return
	end
	
	if not hcombi.cv_combifriends.value then
		printfunc(player, color .. "The server has disabled combi friends. :(", false)
		
		return
	end

	if friend == "none" then
		if player.combi_pending_friend and players[player.combi_pending_friend-1].valid then
			chatprintf(players[player.combi_pending_friend-1], "\x84" .. player.name .. " is no longer your combi friend. :(", true)
		end
		
		player.combi_pending_friend = 65534
		COM_BufInsertText(server, "storage__combi_friend_" .. #player .. " 65534")
		printfunc(player, color .. "You no longer have a combi friend. :(", false)
		
		return
	end
	
	if friend == player.name then
		printfunc(player, color .. "You can't befriend yourself!", false)
		
		return
	end
	
	local friend_player
	for p in players.iterate do
		if p.name == friend then
			friend_player = p
			break
		end
	end

	if not friend_player then
		if not in_chat then
			CONS_Printf(player, "combi_friend \"<name>\": Pick someone to always be your combi partner! They must return the favor.")
		end
		
		return
	end
	
	player.combi_pending_friend = #friend_player+1
	COM_BufInsertText(server, "storage__combi_friend_" .. #player .. " " .. (#friend_player+1))
	
	local str = friend .. " will be your friend if they accept."
	if friend_player.combi_pending_friend and friend_player.combi_pending_friend-1 == #player then
		str = friend .. " will always be your combi partner."
	end
	
	printfunc(player, color .. str, false)

	str = player.name .. " wants to be combi friends. Say \"friend " .. player.name .. "\" to accept."
	if friend_player.combi_pending_friend and friend_player.combi_pending_friend-1 == #player then
		str = player.name .. " accepted your friend request, and will always be your combi partner."
	end

	chatprintf(friend_player, "\x84" .. str, true)
end)

addHook("PlayerMsg", function(player, msgtype, target, message)
	if message:sub(1, 7) == "friend " then
		COM_BufInsertText(player, "combi_friend \"" .. message:sub(8) .. "\" in_chat")
	end
end)